petsc-3.7.1 2016-05-15
Report Typos and Errors

# MatPreallocateInitialize

Begins the block of code that will count the number of nonzeros per row in a matrix providing the data that one can use to correctly preallocate the matrix.

### Synopsis

    #include <petscmat.h>
    PetscErrorCode MatPreallocateInitialize(MPI_Comm comm, PetscInt nrows, PetscInt ncols, PetscInt *dnz, PetscInt *onz)

Collective on MPI_Comm Many br

### Input Parameters

| comm | - the communicator that will share the eventually allocated matrix Many br
| nrows | - the number of LOCAL rows in the matrix Many br
| ncols | - the number of LOCAL columns in the matrix Many br

### Output Parameters

| dnz | - the array that will be passed to the matrix preallocation routines Many br
| ozn | - the other array passed to the matrix preallocation routines Many br

Many br

### Notes

See Users-Manual: Chapter 14 Hints for Performance Tuning for more details. Many br

Do not malloc or free dnz and onz, that is handled internally by these routines Many br

Use MatPreallocateInitializeSymmetric() for symmetric matrices (MPISBAIJ matrices) Many br

This is a MACRO not a function because it has a leading { that is closed by PetscPreallocateFinalize(). Many br

### See Also

MatPreallocateFinalize(), MatPreallocateSet(), MatPreallocateSymmetricSetBlock(), MatPreallocateSetLocal(),
MatPreallocateInitializeSymmetric(), MatPreallocateSymmetricSetLocalBlock() Many br

Level:intermediate
Location:src/mat/../../include/petscmat.h
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages